/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (http://www.swig.org).
 * Version 4.0.2
 *
 * Do not make changes to this file unless you know what you are doing--modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */
package com.herumi.mcl

object MclJNI {
    external fun SystemInit(jarg1: Int)
    external fun neg__SWIG_0(jarg1: Long, jarg1_: Fr?, jarg2: Long, jarg2_: Fr?)
    external fun inv__SWIG_0(jarg1: Long, jarg1_: Fr?, jarg2: Long, jarg2_: Fr?)
    external fun add__SWIG_0(
        jarg1: Long,
        jarg1_: Fr?,
        jarg2: Long,
        jarg2_: Fr?,
        jarg3: Long,
        jarg3_: Fr?
    )

    external fun sub__SWIG_0(
        jarg1: Long,
        jarg1_: Fr?,
        jarg2: Long,
        jarg2_: Fr?,
        jarg3: Long,
        jarg3_: Fr?
    )

    external fun mul__SWIG_0(
        jarg1: Long,
        jarg1_: Fr?,
        jarg2: Long,
        jarg2_: Fr?,
        jarg3: Long,
        jarg3_: Fr?
    )

    external fun mul__SWIG_1(
        jarg1: Long,
        jarg1_: G1?,
        jarg2: Long,
        jarg2_: G1?,
        jarg3: Long,
        jarg3_: Fr?
    )

    external fun mul__SWIG_2(
        jarg1: Long,
        jarg1_: G2?,
        jarg2: Long,
        jarg2_: G2?,
        jarg3: Long,
        jarg3_: Fr?
    )

    external fun div__SWIG_0(
        jarg1: Long,
        jarg1_: Fr?,
        jarg2: Long,
        jarg2_: Fr?,
        jarg3: Long,
        jarg3_: Fr?
    )

    external fun pow(jarg1: Long, jarg1_: GT?, jarg2: Long, jarg2_: GT?, jarg3: Long, jarg3_: Fr?)
    external fun new_Fr__SWIG_0(): Long
    external fun new_Fr__SWIG_1(jarg1: Long, jarg1_: Fr?): Long
    external fun new_Fr__SWIG_2(jarg1: Int): Long
    external fun new_Fr__SWIG_3(jarg1: String?, jarg2: Int): Long
    external fun new_Fr__SWIG_4(jarg1: String?): Long
    external fun Fr_equals(jarg1: Long, jarg1_: Fr?, jarg2: Long, jarg2_: Fr?): Boolean
    external fun Fr_isZero(jarg1: Long, jarg1_: Fr?): Boolean
    external fun Fr_isOne(jarg1: Long, jarg1_: Fr?): Boolean
    external fun Fr_setStr__SWIG_0(jarg1: Long, jarg1_: Fr?, jarg2: String?, jarg3: Int)
    external fun Fr_setStr__SWIG_1(jarg1: Long, jarg1_: Fr?, jarg2: String?)
    external fun Fr_setInt(jarg1: Long, jarg1_: Fr?, jarg2: Int)
    external fun Fr_clear(jarg1: Long, jarg1_: Fr?)
    external fun Fr_setByCSPRNG(jarg1: Long, jarg1_: Fr?)
    external fun Fr_toString__SWIG_0(jarg1: Long, jarg1_: Fr?, jarg2: Int): String?
    external fun Fr_toString__SWIG_1(jarg1: Long, jarg1_: Fr?): String?
    external fun Fr_deserialize(jarg1: Long, jarg1_: Fr?, jarg2: ByteArray?)
    external fun Fr_setLittleEndianMod(jarg1: Long, jarg1_: Fr?, jarg2: ByteArray?)
    external fun Fr_setHashOf(jarg1: Long, jarg1_: Fr?, jarg2: ByteArray?)
    external fun Fr_serialize(jarg1: Long, jarg1_: Fr?): ByteArray?
    external fun delete_Fr(jarg1: Long)
    external fun neg__SWIG_1(jarg1: Long, jarg1_: Fp?, jarg2: Long, jarg2_: Fp?)
    external fun inv__SWIG_1(jarg1: Long, jarg1_: Fp?, jarg2: Long, jarg2_: Fp?)
    external fun add__SWIG_1(
        jarg1: Long,
        jarg1_: Fp?,
        jarg2: Long,
        jarg2_: Fp?,
        jarg3: Long,
        jarg3_: Fp?
    )

    external fun sub__SWIG_1(
        jarg1: Long,
        jarg1_: Fp?,
        jarg2: Long,
        jarg2_: Fp?,
        jarg3: Long,
        jarg3_: Fp?
    )

    external fun mul__SWIG_3(
        jarg1: Long,
        jarg1_: Fp?,
        jarg2: Long,
        jarg2_: Fp?,
        jarg3: Long,
        jarg3_: Fp?
    )

    external fun div__SWIG_1(
        jarg1: Long,
        jarg1_: Fp?,
        jarg2: Long,
        jarg2_: Fp?,
        jarg3: Long,
        jarg3_: Fp?
    )

    external fun new_Fp__SWIG_0(): Long
    external fun new_Fp__SWIG_1(jarg1: Long, jarg1_: Fp?): Long
    external fun new_Fp__SWIG_2(jarg1: Int): Long
    external fun new_Fp__SWIG_3(jarg1: String?, jarg2: Int): Long
    external fun new_Fp__SWIG_4(jarg1: String?): Long
    external fun Fp_equals(jarg1: Long, jarg1_: Fp?, jarg2: Long, jarg2_: Fp?): Boolean
    external fun Fp_isZero(jarg1: Long, jarg1_: Fp?): Boolean
    external fun Fp_isOne(jarg1: Long, jarg1_: Fp?): Boolean
    external fun Fp_setStr__SWIG_0(jarg1: Long, jarg1_: Fp?, jarg2: String?, jarg3: Int)
    external fun Fp_setStr__SWIG_1(jarg1: Long, jarg1_: Fp?, jarg2: String?)
    external fun Fp_setInt(jarg1: Long, jarg1_: Fp?, jarg2: Int)
    external fun Fp_clear(jarg1: Long, jarg1_: Fp?)
    external fun Fp_setByCSPRNG(jarg1: Long, jarg1_: Fp?)
    external fun Fp_toString__SWIG_0(jarg1: Long, jarg1_: Fp?, jarg2: Int): String?
    external fun Fp_toString__SWIG_1(jarg1: Long, jarg1_: Fp?): String?
    external fun Fp_deserialize(jarg1: Long, jarg1_: Fp?, jarg2: ByteArray?)
    external fun Fp_serialize(jarg1: Long, jarg1_: Fp?): ByteArray?
    external fun delete_Fp(jarg1: Long)
    external fun neg__SWIG_2(jarg1: Long, jarg1_: G1?, jarg2: Long, jarg2_: G1?)
    external fun dbl__SWIG_0(jarg1: Long, jarg1_: G1?, jarg2: Long, jarg2_: G1?)
    external fun add__SWIG_2(
        jarg1: Long,
        jarg1_: G1?,
        jarg2: Long,
        jarg2_: G1?,
        jarg3: Long,
        jarg3_: G1?
    )

    external fun sub__SWIG_2(
        jarg1: Long,
        jarg1_: G1?,
        jarg2: Long,
        jarg2_: G1?,
        jarg3: Long,
        jarg3_: G1?
    )

    external fun pairing(
        jarg1: Long,
        jarg1_: GT?,
        jarg2: Long,
        jarg2_: G1?,
        jarg3: Long,
        jarg3_: G2?
    )

    external fun hashAndMapToG1(jarg1: Long, jarg1_: G1?, jarg2: ByteArray?)
    external fun new_G1__SWIG_0(): Long
    external fun new_G1__SWIG_1(jarg1: Long, jarg1_: G1?): Long
    external fun new_G1__SWIG_2(jarg1: Long, jarg1_: Fp?, jarg2: Long, jarg2_: Fp?): Long
    external fun G1_equals(jarg1: Long, jarg1_: G1?, jarg2: Long, jarg2_: G1?): Boolean
    external fun G1_isZero(jarg1: Long, jarg1_: G1?): Boolean
    external fun G1_isValidOrder(jarg1: Long, jarg1_: G1?): Boolean
    external fun G1_set(
        jarg1: Long,
        jarg1_: G1?,
        jarg2: Long,
        jarg2_: Fp?,
        jarg3: Long,
        jarg3_: Fp?
    )

    external fun G1_clear(jarg1: Long, jarg1_: G1?)
    external fun G1_setStr__SWIG_0(jarg1: Long, jarg1_: G1?, jarg2: String?, jarg3: Int)
    external fun G1_setStr__SWIG_1(jarg1: Long, jarg1_: G1?, jarg2: String?)
    external fun G1_toString__SWIG_0(jarg1: Long, jarg1_: G1?, jarg2: Int): String?
    external fun G1_toString__SWIG_1(jarg1: Long, jarg1_: G1?): String?
    external fun G1_deserialize(jarg1: Long, jarg1_: G1?, jarg2: ByteArray?)
    external fun G1_serialize(jarg1: Long, jarg1_: G1?): ByteArray?
    external fun G1_normalize(jarg1: Long, jarg1_: G1?)
    external fun G1_tryAndIncMapTo(jarg1: Long, jarg1_: G1?, jarg2: Long, jarg2_: Fp?)
    external fun G1_getX(jarg1: Long, jarg1_: G1?): Long
    external fun G1_getY(jarg1: Long, jarg1_: G1?): Long
    external fun G1_getZ(jarg1: Long, jarg1_: G1?): Long
    external fun delete_G1(jarg1: Long)
    external fun neg__SWIG_3(jarg1: Long, jarg1_: G2?, jarg2: Long, jarg2_: G2?)
    external fun dbl__SWIG_1(jarg1: Long, jarg1_: G2?, jarg2: Long, jarg2_: G2?)
    external fun add__SWIG_3(
        jarg1: Long,
        jarg1_: G2?,
        jarg2: Long,
        jarg2_: G2?,
        jarg3: Long,
        jarg3_: G2?
    )

    external fun sub__SWIG_3(
        jarg1: Long,
        jarg1_: G2?,
        jarg2: Long,
        jarg2_: G2?,
        jarg3: Long,
        jarg3_: G2?
    )

    external fun hashAndMapToG2(jarg1: Long, jarg1_: G2?, jarg2: ByteArray?)
    external fun new_G2__SWIG_0(): Long
    external fun new_G2__SWIG_1(jarg1: Long, jarg1_: G2?): Long
    external fun new_G2__SWIG_2(
        jarg1: Long,
        jarg1_: Fp?,
        jarg2: Long,
        jarg2_: Fp?,
        jarg3: Long,
        jarg3_: Fp?,
        jarg4: Long,
        jarg4_: Fp?
    ): Long

    external fun G2_equals(jarg1: Long, jarg1_: G2?, jarg2: Long, jarg2_: G2?): Boolean
    external fun G2_isZero(jarg1: Long, jarg1_: G2?): Boolean
    external fun G2_set(
        jarg1: Long,
        jarg1_: G2?,
        jarg2: Long,
        jarg2_: Fp?,
        jarg3: Long,
        jarg3_: Fp?,
        jarg4: Long,
        jarg4_: Fp?,
        jarg5: Long,
        jarg5_: Fp?
    )

    external fun G2_clear(jarg1: Long, jarg1_: G2?)
    external fun G2_setStr__SWIG_0(jarg1: Long, jarg1_: G2?, jarg2: String?, jarg3: Int)
    external fun G2_setStr__SWIG_1(jarg1: Long, jarg1_: G2?, jarg2: String?)
    external fun G2_toString__SWIG_0(jarg1: Long, jarg1_: G2?, jarg2: Int): String?
    external fun G2_toString__SWIG_1(jarg1: Long, jarg1_: G2?): String?
    external fun G2_deserialize(jarg1: Long, jarg1_: G2?, jarg2: ByteArray?)
    external fun G2_serialize(jarg1: Long, jarg1_: G2?): ByteArray?
    external fun G2_normalize(jarg1: Long, jarg1_: G2?)
    external fun delete_G2(jarg1: Long)
    external fun mul__SWIG_4(
        jarg1: Long,
        jarg1_: GT?,
        jarg2: Long,
        jarg2_: GT?,
        jarg3: Long,
        jarg3_: GT?
    )

    external fun inv__SWIG_2(jarg1: Long, jarg1_: GT?, jarg2: Long, jarg2_: GT?)
    external fun new_GT__SWIG_0(): Long
    external fun new_GT__SWIG_1(jarg1: Long, jarg1_: GT?): Long
    external fun GT_equals(jarg1: Long, jarg1_: GT?, jarg2: Long, jarg2_: GT?): Boolean
    external fun GT_isOne(jarg1: Long, jarg1_: GT?): Boolean
    external fun GT_clear(jarg1: Long, jarg1_: GT?)
    external fun GT_setStr__SWIG_0(jarg1: Long, jarg1_: GT?, jarg2: String?, jarg3: Int)
    external fun GT_setStr__SWIG_1(jarg1: Long, jarg1_: GT?, jarg2: String?)
    external fun GT_toString__SWIG_0(jarg1: Long, jarg1_: GT?, jarg2: Int): String?
    external fun GT_toString__SWIG_1(jarg1: Long, jarg1_: GT?): String?
    external fun GT_deserialize(jarg1: Long, jarg1_: GT?, jarg2: ByteArray?)
    external fun GT_serialize(jarg1: Long, jarg1_: GT?): ByteArray?
    external fun delete_GT(jarg1: Long)
    external fun verifyOrderG1(jarg1: Boolean)
    external fun verifyOrderG2(jarg1: Boolean)
}